/** Fonctions pour le port serie **/

#include <avr/io.h>
#include <stdio.h>

#include "serial.h"

int serie_ouverture(long int vitesse){
UBRR0 = F_CPU/(((unsigned long int)vitesse)<<4)-1;

/* Enable transmitter & receiver */
UCSR0B = (1<<TXEN0 | 1<<RXEN0);

/* Set 8 bits character and 1 stop bit */
UCSR0C = (1<<UCSZ01 | 1<<UCSZ00);

/* Set off UART baud doubler */
UCSR0A &= ~(1 << U2X0);

return 0;
}

int serie_ecrire(void *donnees,int taille){
int i;
for(i=0;i<taille;i++){
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = *((char *)donnees+i);
  }
return taille;
}

int serie_lire(void *donnees,int taille){
if(taille<=0) return 0;
int i;
for(i=0;i<taille;i++){
  loop_until_bit_is_set(UCSR0A, RXC0);
  ((char *)donnees)[i]=UDR0;
  }
return taille;
}
